# wxFTP Class Reference
[Networking]

`#include <wx/protocol/ftp.h>`

Inheritance diagram for wxFTP:
[legend]

## Detailed Description

wxFTP can be used to establish a connection to an FTP server and perform all the usual operations.

Please consult the RFC 959 (http://www.w3.org/Protocols/rfc959/) for more details about the FTP protocol.

wxFTP can thus be used to create a (basic) FTP client.

To use a command which doesn't involve file transfer (i.e. directory oriented commands) you just need to call a corresponding member function or use the generic wxFTP::SendCommand() method. However to actually transfer files you just get or give a stream to or from this class and the actual data are read or written using the usual stream methods.

Example of using wxFTP for file downloading:

            wxFTP ftp;

            // if you don't use these lines anonymous login will be used
            ftp.SetUser("user");
            ftp.SetPassword("password");

            if ( !ftp.Connect("ftp.wxwidgets.org") )
            {
                wxLogError("Couldn't connect");
                return;
            }

            ftp.ChDir("/pub/2.8.9");
            const char *filename = "wxWidgets-2.8.9.tar.bz2";
            int size = ftp.GetFileSize(filename);
            if ( size == -1 )
            {
                wxLogError("Couldn't get the file size for \"%s\"", filename);
            }

            wxInputStream *i = ftp.GetInputStream(filename);
            if ( !in )
            {
                wxLogError("Couldn't get the file");
            }
            else
            {
                char *data = new char[size];
                if ( !in->Read(data, size) )
                {
                    wxLogError("Read error: %d", ftp.GetError());
                }
                else
                {
                    // file data is in the buffer
                    ...
                }

                delete [] data;
                delete in;
            }

            // gracefully close the connection to the server
            ftp.Close();

To upload a file you would do (assuming the connection to the server was opened successfully):

            wxOutputStream *out = ftp.GetOutputStream("filename");
            if ( out )
            {
                out->Write(...); // your data
                delete out;
            }

##

Library: wxNet

Category: Networking

See also:
  wxSocketBase

## Public Member Functions
| wxFTP ()
| Default constructor.
virtual | ~wxFTP ()
| Destructor will close the connection if connected.
virtual bool | Connect (const wxString &host)
| Connect to the FTP server to default port (21) of the specified host.
virtual bool | Connect (const wxString &host, unsigned short port)
| Connect to the FTP server to any port of the specified host.
Functions for managing the FTP connection
virtual bool | Abort ()
| Aborts the download currently in process, returns true if ok, false if an error occurred.
virtual bool | Close ()
| Gracefully closes the connection with the server.
bool | CheckCommand (const wxString &command, char ret)
| Send the specified command to the FTP server.
const wxString & | GetLastResult ()
| Returns the last command result, i.e.
char | SendCommand (const wxString &command)
| Send the specified command to the FTP server and return the first character of the return code.
bool | SetAscii ()
| Sets the transfer mode to ASCII.
bool | SetBinary ()
| Sets the transfer mode to binary.
void | SetPassive (bool pasv)
| If pasv is true, passive connection to the FTP server is used.
virtual void | SetPassword (const wxString &passwd)
| Sets the password to be sent to the FTP server to be allowed to log in.
bool | SetTransferMode (TransferMode mode)
| Sets the transfer mode to the specified one.
virtual void | SetUser (const wxString &user)
| Sets the user name to be sent to the FTP server to be allowed to log in.
Filesystem commands
bool | ChDir (const wxString &dir)
| Change the current FTP working directory.
bool | MkDir (const wxString &dir)
| Create the specified directory in the current FTP working directory.
wxString | Pwd ()
| Returns the current FTP working directory.
bool | Rename (const wxString &src, const wxString &dst)
| Rename the specified src element to dst.
bool | RmDir (const wxString &dir)
| Remove the specified directory from the current FTP working directory.
bool | RmFile (const wxString &path)
| Delete the file specified by path.
bool | FileExists (const wxString &filename)
| Returns true if the given remote file exists, false otherwise.
bool | GetDirList (wxArrayString &files, const wxString &wildcard=wxEmptyString)
| The GetList() function is quite low-level.
int | GetFileSize (const wxString &filename)
| Returns the file size in bytes or -1 if the file doesn't exist or the size couldn't be determined.
bool | GetFilesList (wxArrayString &files, const wxString &wildcard=wxEmptyString)
| This function returns the computer-parsable list of the files in the current directory (optionally only of the files matching the wildcard, all files by default).
Download and upload functions
virtual wxInputStream * | GetInputStream (const wxString &path)
| Creates a new input stream on the specified path.
virtual wxOutputStream * | GetOutputStream (const wxString &file)
| Initializes an output stream to the specified file.

List of all members.

## Constructor & Destructor Documentation

wxFTP::wxFTP | ( |  | ) |

Default constructor.

virtual wxFTP::~wxFTP | ( |  | ) | `[virtual]`

Destructor will close the connection if connected.

## Member Function Documentation

virtual bool wxFTP::Abort | ( |  | ) | `[virtual]`

Aborts the download currently in process, returns true if ok, false if an error occurred.

Implements wxProtocol.

bool wxFTP::ChDir | ( | const wxString & | dir | ) |

Change the current FTP working directory.

Returns true if successful.

bool wxFTP::CheckCommand | ( | const wxString & | command,
|  | char | ret |
| ) |  |  |

Send the specified command to the FTP server.

ret specifies the expected result.

Returns:
  true if the command has been sent successfully, else false.

virtual bool wxFTP::Close | ( |  | ) | `[virtual]`

Gracefully closes the connection with the server.

Reimplemented from wxSocketBase.

virtual bool wxFTP::Connect | ( | const wxString & | host,
|  | unsigned short | port |
| ) |  |  | `[virtual]`

Connect to the FTP server to any port of the specified host.

By default (port = 0), connection is made to default FTP port (21) of the specified host.

Since:
  2.9.1

virtual bool wxFTP::Connect | ( | const wxString & | host | ) | `[virtual]`

Connect to the FTP server to default port (21) of the specified host.

bool wxFTP::FileExists | ( | const wxString & | filename | ) |

Returns true if the given remote file exists, false otherwise.

bool wxFTP::GetDirList | ( | wxArrayString & | files,
|  | const wxString & | wildcard = `wxEmptyString` |
| ) |  |  |

The GetList() function is quite low-level.

It returns the list of the files in the current directory. The list can be filtered using the wildcard string.

If wildcard is empty (default), it will return all files in directory. The form of the list can change from one peer system to another. For example, for a UNIX peer system, it will look like this:

            -r--r--r--   1 guilhem  lavaux      12738 Jan 16 20:17 cmndata.cpp
            -r--r--r--   1 guilhem  lavaux      10866 Jan 24 16:41 config.cpp
            -rw-rw-rw-   1 guilhem  lavaux      29967 Dec 21 19:17 cwlex_yy.c
            -rw-rw-rw-   1 guilhem  lavaux      14342 Jan 22 19:51 cwy_tab.c
            -r--r--r--   1 guilhem  lavaux      13890 Jan 29 19:18 date.cpp
            -r--r--r--   1 guilhem  lavaux       3989 Feb  8 19:18 datstrm.cpp

But on Windows system, it will look like this:

            winamp~1 exe    520196 02-25-1999  19:28  winamp204.exe
                1 file(s)           520 196 bytes

Returns:
  true if the file list was successfully retrieved, false otherwise.

See also:
  GetFilesList()

int wxFTP::GetFileSize | ( | const wxString & | filename | ) |

Returns the file size in bytes or -1 if the file doesn't exist or the size couldn't be determined.

Notice that this size can be approximative size only and shouldn't be used for allocating the buffer in which the remote file is copied, for example.

bool wxFTP::GetFilesList | ( | wxArrayString & | files,
|  | const wxString & | wildcard = `wxEmptyString` |
| ) |  |  |

This function returns the computer-parsable list of the files in the current directory (optionally only of the files matching the wildcard, all files by default).

This list always has the same format and contains one full (including the directory path) file name per line.

Returns:
  true if the file list was successfully retrieved, false otherwise.

See also:
  GetDirList()

virtual wxInputStream* wxFTP::GetInputStream | ( | const wxString & | path | ) | `[virtual]`

Creates a new input stream on the specified path.

You can use all but the seek functionality of wxStreamBase. wxStreamBase::Seek() isn't available on all streams. For example, HTTP or FTP streams do not deal with it. Other functions like wxStreamBase::Tell() are not available for this sort of stream, at present.

You will be notified when the EOF is reached by an error.

Returns:
  Returns NULL if an error occurred (it could be a network failure or the fact that the file doesn't exist).

Implements wxProtocol.

const wxString& wxFTP::GetLastResult | ( |  | ) |

Returns the last command result, i.e.

the full server reply for the last command.

virtual wxOutputStream* wxFTP::GetOutputStream | ( | const wxString & | file | ) | `[virtual]`

Initializes an output stream to the specified file.

The returned stream has all but the seek functionality of wxStreams. When the user finishes writing data, he has to delete the stream to close it.

Returns:
  An initialized write-only stream. Returns NULL if an error occurred (it could be a network failure or the fact that the file doesn't exist).

bool wxFTP::MkDir | ( | const wxString & | dir | ) |

Create the specified directory in the current FTP working directory.

Returns true if successful.

wxString wxFTP::Pwd | ( |  | ) |

Returns the current FTP working directory.

bool wxFTP::Rename | ( | const wxString & | src,
|  | const wxString & | dst |
| ) |  |  |

Rename the specified src element to dst.

Returns true if successful.

bool wxFTP::RmDir | ( | const wxString & | dir | ) |

Remove the specified directory from the current FTP working directory.

Returns true if successful.

bool wxFTP::RmFile | ( | const wxString & | path | ) |

Delete the file specified by path.

Returns true if successful.

char wxFTP::SendCommand | ( | const wxString & | command | ) |

Send the specified command to the FTP server and return the first character of the return code.

bool wxFTP::SetAscii | ( |  | ) |

Sets the transfer mode to ASCII.

It will be used for the next transfer.

bool wxFTP::SetBinary | ( |  | ) |

Sets the transfer mode to binary.

It will be used for the next transfer.

void wxFTP::SetPassive | ( | bool | pasv | ) |

If pasv is true, passive connection to the FTP server is used.

This is the default as it works with practically all firewalls. If the server doesn't support passive mode, you may call this function with false as argument to use an active connection.

virtual void wxFTP::SetPassword | ( | const wxString & | passwd | ) | `[virtual]`

Sets the password to be sent to the FTP server to be allowed to log in.

Reimplemented from wxProtocol.

bool wxFTP::SetTransferMode | ( | TransferMode | mode | ) |

Sets the transfer mode to the specified one.

It will be used for the next transfer.

If this function is never called, binary transfer mode is used by default.

virtual void wxFTP::SetUser | ( | const wxString & | user | ) | `[virtual]`

Sets the user name to be sent to the FTP server to be allowed to log in.

Reimplemented from wxProtocol.

|  | [ top ]